# Changelog

All notable changes to this project will be documented in this file.

## [0.10.0] - 2024-03-04

### docs

- Add packages repository to list of projects using this

### version

- Implement Stringer for token
- Add function to validate versions
- Add version specification

## [0.9.0] - 2024-01-17

### repository

- Package: add support for the provider_priority field
- Sign apk index

## [0.8.0] - 2023-09-03

### apkbuild

- Switch to gopkg.in/yaml.v3

### parser

- Switch to interp.ExecHandlers

### pkg

- [**breaking**] Remove backwards compatibility package

## [0.7.0] - 2023-04-30

### apkindex

- Parse replaces lines from apk indexes

### go.mod

- Bump go version to 1.19

### package

- Parse replaces data from the PKGINFO block

### readme

- Update example import statements
- Improve package descriptions
- Add list of community projects

### releases

- Include information about keys

### version

- Add package with version parsing routines
- Fix up some tokenization edge cases
- Add tokenizer tests
- Add documentation

## [0.6.0] - 2022-09-07

### apkbuild

- Add builddir parsing
- Add Source#IsRemote method
- Expose shell functions

## [0.5.1] - 2022-07-26

### apkbuild

- Treat z as a letter in pkgspec parsing

### go.mod

- Bump testify to v1.8.0

## [0.5.0] - 2022-06-13

### apbuild

- Parse basic information
- Move out of pkg

### apkbuild

- Parse options
- Support parsing package specs
- Parse dependency related fields
- Parse arch
- Parse sources
- Parse subpackages
- Parse sha512sums
- Parse install related fields
- Parse triggers
- Add documentation
- Add acceptance tests
- Check runner.Run return value
- Address gocritic ifElseChain

### pkg/apkbuild

- Remove left-behind file

### releases

- Move out of pkg

### repository

- Move out of pkg
- Remove extra whitespace

### secfixes

- Fix panic due to non-string keys

### various

- Address commentFormatting linting

## [0.4.0] - 2022-03-23

### readme

- Fix some typos and old data

### repository

- Allow using plain io.Reader in ParsePackageIndex
- Move deferred close after err check
- Use lowercase error messages

### secfixes

- Restructure to support line numbers

## [0.3.1] - 2022-03-10

## [0.3.0] - 2021-11-27

### repository

- Rename from apkindex package
- Extract package struct to separate file
- Add structs to work with entire repositories

## [0.2.1] - 2021-04-27

### module

- Improve documentation

### releases

- Split fetch function

## [0.2.0] - 2021-04-26

### releases

- Package to fetch and parse alpine releasedata

## [0.1.2] - 2021-04-26

### secfixes

- Properly break out of loop

## [0.1.1] - 2021-04-25

### secfixes

- Handle lines with only a '#'

## [0.1.0] - 2021-04-25

### apkbuild

- A package to parse APBUILD files

### apkindex

- Add package to parse index files

### go.mod

- Rename module to match upstream repo

### readme

- Add documentation for the apkindex package

<!-- generated by git-cliff -->
